<%|eat|
	<%/* HANDLE REDIS SESSION COOKIE AND DECIDE WHICH REDIS ENGINE TO USE */%>
	<%(&has_cookie($(mobile.session_cookie.name)) != "1")
		<%|define("rand")|&random_range(100000000, 999999999)%>
		<%|define("session_cookie")|&concat($(common.redis.master),$(common.session.id_separator))<%|sha1_hex|&concat(%rand, "_", %NOW, "_", %REMOTE_BROWSER)%>%>

		<%|set_secure_cookie($(mobile.session_cookie.name), "m", &multiply($(mobile.session_cookie.expiration), "30"))|%session_cookie%>
	%>
	<%|define("session_key")|&concat(&get_cookie($(mobile.session_cookie.name), "^[a-z0-9]{40,50}$"), "_mobile")%>
	<%(%session_key != "_mobile")
		<%|define_split("session_split", $(common.session.id_separator))|&get_cookie($(mobile.session_cookie.name), "^[a-z0-9]{40,50}$")%>
		<%|define("redis_engine")|$(api.redis.engine)%>

		<%/* IF TEMPLATE VAR sess_clear SET TO 1, REMOVE ALL REDIS HASHES FOR KEY */%>
		<%(?sess_clear && %sess_clear == "1")
			&redis_del(%redis_engine, %session_key)
		%>

		<%/* REMOVE HASHES IN REDIS KEY AS DEFINED IN TEMPLATE VARS PREFIXED sess_del_ */%>
		<%(%sess_del_* != "")
			&redis_hdel(%redis_engine, %session_key, &substring(%sess_del_*, 9))
		%>
		
		<%/* SET HASHES IN REDIS KEY AS DEFINEED IN TEMPLATE VARS PREFIXED sess_set_ */%>
		<%(%[%sess_set_*] != "")
			<%|redis_hset(%redis_engine, %session_key, &substring(%sess_set_*, 9))|%[%%sess_set_*]%>
		%>

		<%/* SET EXPIRATION FOR REDIS KEY AS DEFINED IN BCONF */%>
		<%|redis_expire(%redis_engine, %session_key)|&multiply($(mobile.session_cookie.expiration), "60")%>

		<%/* EXTRACT ALL HASHES IN REDIS KEY AND SET CORRESPODING TEMPLATE VARS PREFIXED sess_ */%>
		<%|redis_hgetall(%redis_engine, %session_key, "sess")|
			<%|define(&concat("sess_", $(sess.*)))|$$(sess.@)%>
		%>
	%>
%>
